package com.virtual.plat.server;

import com.extjs.gxt.ui.client.data.ModelData;
import com.virtual.common.FuncUtil;
import com.virtual.common.StringManager;
import com.virtual.plat.client.operator.LoginInfo;
import com.virtual.plat.server.Executor;
import com.virtual.plat.server.LocalUser;
import com.virtual.plat.server.RequestData;
import com.virtual.plat.server.cloudos.CloudOSHandler;
import com.virtual.plat.server.ldap.LdapHandler;
import com.virtual.plat.server.message.MessageMgr;
import com.virtual.plat.server.operlog.OperationLogMgr;
import com.virtual.plat.server.organize.OrganizationHandler;
import com.virtual.plat.server.publiccloud.PublicCloudHandler;
import com.virtual.plat.server.template.TemplateHandler;
import com.virtual.plat.server.user.UserHandler;
import com.virtual.plat.server.virtualhost.DomainHandler;
import java.util.Date;
import javax.annotation.Resource;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Service;

@Service("cicRequestExecutor")
public class CICRequestExecutor implements Executor {

   private static StringManager strMng = StringManager.getManager(MessageMgr.class);
   @Resource
   protected MessageMgr messageMgr = null;
   private static Log log = LogFactory.getLog(CICRequestExecutor.class);
   @Resource
   private DomainHandler domainHandler = null;
   @Resource
   private TemplateHandler templateHandler = null;
   @Resource
   private PublicCloudHandler publicCloudHandler = null;
   @Resource
   private OrganizationHandler orgHandler = null;
   @Resource
   private OperationLogMgr operationLogMgr = null;
   @Resource
   private UserHandler userHandler = null;
   @Resource
   private CloudOSHandler cloudOSHandler;
   @Resource
   private LdapHandler ldapHandler = null;


   public void executor(RequestData var1) {
      LoginInfo var3;
      (var3 = new LoginInfo()).setUserName(var1.getUserName());
      var3.setLoginName(var1.getLoginName());
      var3.setLoginIp(var1.getIpAddress());
      LocalUser.put(var3);
      ModelData var2;
      Long var5;
      Long.valueOf((var5 = (Long)(var2 = var1.getData()).get("cloudId")) == null?-1L:var5.longValue());
      Integer var4 = var2.get("cloudType") == null?null:Integer.valueOf(var2.get("cloudType").toString());
      log.info("Request type:" + FuncUtil.convertTaskType(var1.getRequestType()));
      this.messageMgr.updateMessage(var1.getMessageId(), new Date());
      switch(var1.getRequestType()) {
      case 21:
         this.domainHandler.deleteDomain(var1);
         return;
      case 26:
         this.domainHandler.repairVm(var1);
         return;
      case 30:
         this.domainHandler.startDomain(var1);
         return;
      case 31:
         this.domainHandler.closeDomain(var1);
         return;
      case 32:
         this.domainHandler.shutdownDomain(var1);
         return;
      case 33:
         this.domainHandler.restartDomain(var1);
         return;
      case 34:
         this.domainHandler.pauseDomain(var1);
         return;
      case 35:
         this.domainHandler.restoreDomain(var1);
         return;
      case 36:
         this.domainHandler.sleepDomain(var1);
         return;
      case 47:
         if(var4 != null && var4.intValue() != 2) {
            this.cloudOSHandler.deployDomain(var1);
            return;
         }

         this.domainHandler.deployDomain(var1);
         return;
      case 48:
         this.templateHandler.deleteTemplet(var1);
         return;
      case 49:
         this.templateHandler.modifyVmTemplate(var1);
         return;
      case 58:
         this.domainHandler.modifyDomainBasicInfo(var1);
         return;
      case 103:
         this.domainHandler.restoreFromRecycleBin(var1);
         return;
      case 175:
         this.domainHandler.handleVmHA(var1);
         return;
      case 190:
         this.publicCloudHandler.SyncResourceFromPublicCloud(var1);
         return;
      case 200:
         this.ldapHandler.syncLdapUser(var1);
         return;
      case 201:
         this.userHandler.importUser(var1);
      case 600:
      case 601:
         this.publicCloudHandler.addPublicCloudRes(var1);
         return;
      case 602:
         this.publicCloudHandler.deleteCasRes(var1);
         return;
      case 803:
         this.orgHandler.SyncOrgTemp(var1);
         return;
      default:
      }
   }

   public void cancel(RequestData var1) {
      this.messageMgr.updateMessage(var1.getMessageId());
      Long var2 = (Long)var1.getData().get("id");
      byte var3;
      if(var1.getRequestType() != 200 && var1.getRequestType() != 201) {
         if(var1.getRequestType() >= 20) {
            var3 = 10;
         } else if(var1.getRequestType() >= 10) {
            var3 = 5;
         } else {
            var3 = 8;
         }
      } else {
         var3 = 11;
      }

      try {
         String var4;
         int var5;
         if((var5 = (var4 = var1.getOperateDesc()).lastIndexOf("。")) > 0) {
            var4 = var4.substring(0, var5);
         } else if((var5 = var4.lastIndexOf(".")) > 0) {
            var4 = var4.substring(0, var5);
         }

         this.operationLogMgr.addFailureLog(var1.getLoginName(), var1.getUserName(), var1.getIpAddress(), var3, strMng.getString("task.cancel.operation", new Object[]{var4}), strMng.getString("task.cancel.msg"), var2);
      } catch (Exception var6) {
         log.error((Object)null, var6);
      }
   }

   private static LoginInfo a(RequestData var0) {
      LoginInfo var1;
      (var1 = new LoginInfo()).setUserName(var0.getUserName());
      var1.setLoginName(var0.getLoginName());
      var1.setLoginIp(var0.getIpAddress());
      return var1;
   }

}
